'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.history = exports.store = exports.DevTools = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxDevtools = require('redux-devtools');

var _reduxDevtoolsLogMonitor = require('redux-devtools-log-monitor');

var _reduxDevtoolsLogMonitor2 = _interopRequireDefault(_reduxDevtoolsLogMonitor);

var _reduxDevtoolsDockMonitor = require('redux-devtools-dock-monitor');

var _reduxDevtoolsDockMonitor2 = _interopRequireDefault(_reduxDevtoolsDockMonitor);

var _reactRouter = require('react-router');

var _reactRouterRedux = require('react-router-redux');

var _redux = require('redux');

var _reactReduxAuth = require('react-redux-auth0');

var test = _interopRequireWildcard(_reactReduxAuth);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//Set up Redux Middleware


//Reducers


//Redux DevTools
var reducer = (0, _redux.combineReducers)({
  auth: _reactReduxAuth.AuthReducer,
  routing: _reactRouterRedux.routerReducer
});

//Set up Dev Tools


//Redux


//React-Router
var DevTools = (0, _reduxDevtools.createDevTools)(_react2.default.createElement(
  _reduxDevtoolsDockMonitor2.default,
  { toggleVisibilityKey: 'ctrl-h',
    changePositionKey: 'ctrl-q' },
  _react2.default.createElement(_reduxDevtoolsLogMonitor2.default, { theme: 'tomorrow', preserveScrollTop: false })
));

//Create the store
var middlewareToApply = (0, _redux.applyMiddleware)(_reactReduxAuth.AuthMiddlewares.TokenMiddleware(), (0, _reactRouterRedux.routerMiddleware)(_reactRouter.browserHistory));
var finalCreateStore = (0, _redux.compose)(middlewareToApply, DevTools.instrument())(_redux.createStore);

var store = finalCreateStore(reducer);
var history = (0, _reactRouterRedux.syncHistoryWithStore)(_reactRouter.browserHistory, store);

//Exports
exports.default = store;
exports.DevTools = DevTools;
exports.store = store;
exports.history = history;